/*
Copyright (C) 2013 NTT DATA Corporation

This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License
as published by the Free Software Foundation, version 2.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
 */
package com.clustercontrol.cloud.aws.presenter;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

public class CreateStorageRequest implements Serializable {
	private static final long serialVersionUID = -4109958036466822934L;

    protected String availabilityZone;
    protected String cloudId;
    protected Integer iops;
    protected String snapshotId;
    protected String storageName;
    protected String storageKind;
    protected Integer storageSize;

    public String getAvailabilityZone() {
        return availabilityZone;
    }

    public void setAvailabilityZone(String value) {
        this.availabilityZone = value;
    }

    public String getCloudId() {
        return cloudId;
    }

    public void setCloudId(String value) {
        this.cloudId = value;
    }

    public Integer getIops() {
        return iops;
    }

    public void setIops(Integer value) {
        this.iops = value;
    }

    public String getSnapshotId() {
        return snapshotId;
    }

    public void setSnapshotId(String value) {
        this.snapshotId = value;
    }

    public String getStorageName() {
        return storageName;
    }

    public void setStorageName(String value) {
        this.storageName = value;
    }

    public String getStorageKind() {
        return storageKind;
    }

    public void setStorageKind(String storageKind) {
        this.storageKind = storageKind;
    }
    
    public Integer getStorageSize() {
        return storageSize;
    }

    public void setStorageSize(Integer value) {
        this.storageSize = value;
    }

	public CreateStorageRequest deepCopy() {
		CreateStorageRequest model = null;
		try {
			ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
			ObjectOutputStream out = new ObjectOutputStream(byteOut);
			out.writeObject(this);
			ByteArrayInputStream byteIn = new ByteArrayInputStream(byteOut.toByteArray());
			ObjectInputStream in = new ObjectInputStream(byteIn);
			model = (CreateStorageRequest)in.readObject();
		}
		catch (Exception e) {
			throw new IllegalStateException(e);
		}
		return model;
	}
}