/*
Copyright (C) 2013 NTT DATA Corporation

This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License
as published by the Free Software Foundation, version 2.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
 */

package com.clustercontrol.cloud.ui.views.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.IStructuredSelection;

import com.clustercontrol.cloud.aws.presenter.IIpPermission;
import com.clustercontrol.cloud.commons.util.MessageManager;
import com.clustercontrol.util.Messages;


public class RevokeIpPermissionAction extends SingleSelectionActionEx {
	public static final String ID = "com.clustercontrol.cloud.ui.views.actions.SubRule";

	private MessageManager bundle_messages = MessageManager.getInstance("messages");

	@Override
	protected void invoke(IAction action) throws InvocationException {
		IIpPermission ip = (IIpPermission)((IStructuredSelection)viewPart.getSite().getSelectionProvider().getSelection()).getFirstElement();

		if (MessageDialog.openConfirm(
			null,
			Messages.getString("confirmed"),
			bundle_messages.getString("views.actions.sub_rule_confirm"))){

			ip.getSecurityGroup().revokeIpPermission(ip);

			// 成功報告ダイアログを生成
			MessageDialog.openInformation(
				null,
				Messages.getString("successful"),
				bundle_messages.getString("views.actions.sub_rule_result"));
		} else {
			return;
		}
	}
}